summaryrefslogtreecommitdiff
path: root/tests/btrfs/210
diff options
context:
space:
mode:
authorQu Wenruo <wqu@suse.com>2020-04-15 14:49:16 +0800
committerEryu Guan <guaneryu@gmail.com>2020-04-20 00:44:02 +0800
commitb04fe27eda770a7c56c77dc0102553ffddddfdb9 (patch)
tree698d1463c8e6fb04cc70571b5be6119da9b0f8e7 /tests/btrfs/210
parent92a6a6cff81e05002d154bc47873444a1d9de2a2 (diff)
btrfs: snapshot creation with qgroup inherit would mark qgroup inconsistent
Test that a new snapshot created with qgroup inherit passed should mark qgroup numbers inconsistent. Such inconsistent flag is required to show that we need a qgroup rescan to make qgroup numbers correct again. This is unavoidable since snapshot creation with qgroup inherit acts as snapshot creation + qgroup relationship assign. See btrfs(5) for why such operation needs qgroup rescan. This test failed on current kernel, the fix is submitted to the btrfs mail list titled: "btrfs: qgroup: Mark qgroup inconsistent if we're inherting snapshot to a new qgroup" Signed-off-by: Qu Wenruo <wqu@suse.com> Reviewed-by: Filipe Manana <fdmanana@suse.com> Signed-off-by: Eryu Guan <guaneryu@gmail.com>
Diffstat (limited to 'tests/btrfs/210')
-rwxr-xr-xtests/btrfs/21062
1 files changed, 62 insertions, 0 deletions
diff --git a/tests/btrfs/210 b/tests/btrfs/210
new file mode 100755
index 00000000..daa76a87
--- /dev/null
+++ b/tests/btrfs/210
@@ -0,0 +1,62 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (C) 2020 SUSE Linux Products GmbH. All Rights Reserved.
+#
+# FS QA Test 210
+#
+# Test that a new snapshot created with qgroup inherit passed should mark
+# qgroup numbers inconsistent.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+
+_scratch_mkfs >/dev/null
+_scratch_mount
+
+$BTRFS_UTIL_PROG subvolume create "$SCRATCH_MNT/src" > /dev/null
+_pwrite_byte 0xcd 0 16M "$SCRATCH_MNT/src/file" > /dev/null
+
+# Sync the fs to ensure data written to disk so that they can be accounted
+# by qgroup
+sync
+$BTRFS_UTIL_PROG quota enable "$SCRATCH_MNT"
+$BTRFS_UTIL_PROG quota rescan -w "$SCRATCH_MNT"
+$BTRFS_UTIL_PROG qgroup create 1/0 "$SCRATCH_MNT"
+
+# Create a snapshot with qgroup inherit
+$BTRFS_UTIL_PROG subvolume snapshot -i 1/0 "$SCRATCH_MNT/src" \
+ "$SCRATCH_MNT/snapshot" > /dev/null
+
+echo "Silence is golden"
+# If qgroup is not marked inconsistent automatically, btrfs check would
+# report error.
+
+# success, all done
+status=0
+exit